summaryrefslogtreecommitdiffstats
path: root/package/6rd/files
diff options
context:
space:
mode:
authorjow <jow@3c298f89-4303-0410-b956-a3cf2f4a3e73>2012-06-18 23:08:18 +0000
committerjow <jow@3c298f89-4303-0410-b956-a3cf2f4a3e73>2012-06-18 23:08:18 +0000
commitfad2bfb9e150306f0eaee8c260e9e0f7103e400b (patch)
tree9eb34cd43a426fbec9a90d49ca9940ac05b20b50 /package/6rd/files
parent2ffacfdd8e515324bcaf15f55fa2254c25549b8a (diff)
Add new package for configuring 6rd tunnels.
This patch adds support for manually configuring 6rd tunnels. It depends on the netifd patches I sent earlier, which add 6rd support. A basic interface configuration looks like: config interface 'wan6' option proto '6rd' option peeraddr '192.0.2.1' option ip6prefix '2123::' option ip6prefixlen '16' option ip4prefixlen '0' Where ip4prefixlen is optional and actually defaults to 0, which would use all bits of the IPv4 in the calculated IPv6 subnet. I believe it should be possible to configure a regular 6to4 tunnel using this, and that we may want to merge the two eventually, but there are some larger differences between the two at the moment: - 6rd addresses can be more difficult to calculate. My ISP, for example, has a setup with a v6 mask of 43 bits, and a v4 mask of 19. - 6to4 has support for configuring radvd. This is something we want, of course, but it seems best to deal with this in a separate patch. Just creating a new package looked like the quickest way to get this in. This work is based on the 6in4 package, and work by Stijn Tintel. Signed-off-by: Stéphan Kochen <stephan@kochen.nl> git-svn-id: svn://svn.openwrt.org/openwrt/trunk@32431 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package/6rd/files')
-rw-r--r--package/6rd/files/6rd.hotplug29
-rw-r--r--package/6rd/files/6rd.sh83
2 files changed, 112 insertions, 0 deletions
diff --git a/package/6rd/files/6rd.hotplug b/package/6rd/files/6rd.hotplug
new file mode 100644
index 000000000..f38526c53
--- /dev/null
+++ b/package/6rd/files/6rd.hotplug
@@ -0,0 +1,29 @@
+#!/bin/sh
+
+if [ "$ACTION" = ifup ]; then
+ . /lib/functions.sh
+
+ INCLUDE_ONLY=1
+ . /lib/netifd/proto/6rd.sh
+
+ include /lib/network
+ scan_interfaces
+
+ update_tunnel() {
+ local cfg="$1"
+
+ local proto
+ config_get proto "$cfg" proto
+ [ "$proto" = 6rd ] || return 0
+
+ local wandev
+ config_get wandev "$cfg" wan_device "$(find_6rd_wanif)"
+ [ "$wandev" = "$DEVICE" ] || return 0
+
+ local wanip=$(find_6rd_wanip "$wandev")
+
+ [ -n "$wanip" ] && ifup "$cfg"
+ }
+
+ config_foreach update_tunnel interface
+fi
diff --git a/package/6rd/files/6rd.sh b/package/6rd/files/6rd.sh
new file mode 100644
index 000000000..3786ef06f
--- /dev/null
+++ b/package/6rd/files/6rd.sh
@@ -0,0 +1,83 @@
+#!/bin/sh
+# 6rd.sh - IPv6-in-IPv4 tunnel backend
+# Copyright (c) 2010-2012 OpenWrt.org
+
+[ -n "$INCLUDE_ONLY" ] || {
+ . /lib/functions.sh
+ . /lib/functions/network.sh
+ . ../netifd-proto.sh
+ init_proto "$@"
+}
+
+tun_error() {
+ local cfg="$1"; shift;
+
+ [ -n "$1" ] && proto_notify_error "$cfg" "$@"
+ proto_block_restart "$cfg"
+}
+
+proto_6rd_setup() {
+ local cfg="$1"
+ local iface="$2"
+ local link="6rd-$cfg"
+
+ local mtu ttl ipaddr peeraddr ip6prefix ip6prefixlen ip4prefixlen
+ json_get_vars mtu ttl ipaddr peeraddr ip6prefix ip6prefixlen ip4prefixlen
+
+ [ -z "$ip6prefix" -o -z "$peeraddr" ] && {
+ tun_error "$cfg" "MISSING_ADDRESS"
+ return
+ }
+
+ [ -z "$ipaddr" ] && {
+ local wanif
+ if ! network_find_wan wanif || ! network_get_ipaddr ipaddr "$wanif"; then
+ tun_error "$cfg" "NO_WAN_LINK"
+ return
+ fi
+ }
+
+ # Determine the relay prefix.
+ local ip4prefixlen="${ip4prefixlen:-0}"
+ local ip4prefix=$(ipcalc.sh "$ipaddr/$ip4prefixlen" | grep NETWORK)
+ ip4prefix="${ip4prefix#NETWORK=}"
+
+ # Determine our IPv6 address.
+ local ip6subnet=$(6rdcalc "$ip6prefix/$ip6prefixlen" "$ipaddr/$ip4prefixlen")
+ local ip6addr="${ip6subnet%%::*}::1"
+
+ proto_init_update "$link" 1
+ proto_add_ipv6_address "$ip6addr" "$ip6prefixlen"
+ proto_add_ipv6_route "::" 0 "::$peeraddr"
+
+ proto_add_tunnel
+ json_add_string mode sit
+ json_add_int mtu "${mtu:-1280}"
+ json_add_int ttl "${ttl:-64}"
+ json_add_string local "$ipaddr"
+ json_add_string 6rd-prefix "$ip6prefix/$ip6prefixlen"
+ json_add_string 6rd-relay-prefix "$ip4prefix/$ip4prefixlen"
+ proto_close_tunnel
+
+ proto_send_update "$cfg"
+}
+
+proto_6rd_teardown() {
+ local cfg="$1"
+}
+
+proto_6rd_init_config() {
+ no_device=1
+ available=1
+
+ proto_config_add_int "mtu"
+ proto_config_add_int "ttl"
+ proto_config_add_string "peeraddr"
+ proto_config_add_string "ip6prefix"
+ proto_config_add_string "ip6prefixlen"
+ proto_config_add_string "ip4prefixlen"
+}
+
+[ -n "$INCLUDE_ONLY" ] || {
+ add_protocol 6rd
+}